# Rampart Config
[Rampart Utilities]

## Typedefs
typedef struct rampart_config_t | rampart_config_t
## Functions
AXIS2_EXTERN rampart_config_t * | rampart_config_create (const axutil_env_t *env)
AXIS2_EXTERN void | rampart_config_free (rampart_config_t *rampart_config, const axutil_env_t *env)
AXIS2_EXTERN axis2_status_t | rampart_config_set_username (rampart_config_t *rampart_config, const axutil_env_t *env, axis2_char_t *user)
AXIS2_EXTERN axis2_status_t | rampart_config_set_password (rampart_config_t *rampart_config, const axutil_env_t *env, axis2_char_t *password)
AXIS2_EXTERN axis2_status_t | rampart_config_set_password_type (rampart_config_t *rampart_config, const axutil_env_t *env, axis2_char_t *password_type)
AXIS2_EXTERN axis2_status_t | rampart_config_set_ttl (rampart_config_t *rampart_config, const axutil_env_t *env, int ttl)
AXIS2_EXTERN int | rampart_config_add_saml_token (rampart_config_t *rampart_config, const axutil_env_t *env, rampart_saml_token_t *saml)
AXIS2_EXTERN axis2_status_t | rampart_config_set_issued_token_aquire_function (rampart_config_t *rampart_config, const axutil_env_t *env, issued_token_callback_func issued_token_aquire)
AXIS2_EXTERN axis2_char_t * | rampart_config_get_username (rampart_config_t *rampart_config, const axutil_env_t *env)
AXIS2_EXTERN axis2_char_t * | rampart_config_get_password (rampart_config_t *rampart_config, const axutil_env_t *env)
AXIS2_EXTERN axis2_char_t * | rampart_config_get_password_type (rampart_config_t *rampart_config, const axutil_env_t *env)
AXIS2_EXTERN int | rampart_config_get_ttl (rampart_config_t *rampart_config, const axutil_env_t *env)
AXIS2_EXTERN axutil_array_list_t * | rampart_config_get_saml_tokens (rampart_config_t *rampart_config, const axutil_env_t *env)
AXIS2_EXTERN issued_token_callback_func | rampart_config_get_issued_token_aquire_function (rampart_config_t *rampart_config, const axutil_env_t *env)

## Function Documentation

AXIS2_EXTERN int rampart_config_add_saml_token | ( | rampart_config_t * | rampart_config,
|  | const axutil_env_t * | env,
|  | rampart_saml_token_t * | saml |
| ) |  |  |

Sets saml token needed to build/process the message

Parameters:

  | rampart_config | rampart configuration structure
  | evn | pointer to environment struct,Must not b e NULL.
  | saml | SAML token used to build/process the message

Returns:
  status of the op.

AXIS2_EXTERN rampart_config_t* rampart_config_create | ( | const axutil_env_t * | env | ) |

Create a rampart_config which can be used to get rampart specific configurations from user

Parameters:

  | env | pointer to environment struct,Must not be NULL.

Returns:
  ramaprt_config_t* on successful creation. Else NULL;

AXIS2_EXTERN void rampart_config_free | ( | rampart_config_t * | rampart_config,
|  | const axutil_env_t * | env |
| ) |  |  |

Frees a rampart_config.

Parameters:

  | rampart_config | the rampart_config
  | env | pointer to environment struct,Must not be NULL.

AXIS2_EXTERN issued_token_callback_func rampart_config_get_issued_token_aquire_function | ( | rampart_config_t * | rampart_config,
|  | const axutil_env_t * | env |
| ) |  |  |

Gets stored issued token aquire function pointer

Parameters:

  | rampart_config | rampart configuration structure
  | evn | pointer to environment struct,Must not be NULL. returns issued token aquire function pointer stored in rampart config

AXIS2_EXTERN axis2_char_t* rampart_config_get_password | ( | rampart_config_t * | rampart_config,
|  | const axutil_env_t * | env |
| ) |  |  |

Gets stored password

Parameters:

  | rampart_config | rampart configuration structure
  | evn | pointer to environment struct,Must not be NULL. returns password stored in rampart config

AXIS2_EXTERN axis2_char_t* rampart_config_get_password_type | ( | rampart_config_t * | rampart_config,
|  | const axutil_env_t * | env |
| ) |  |  |

Gets stored password type

Parameters:

  | rampart_config | rampart configuration structure
  | evn | pointer to environment struct,Must not be NULL. returns password type stored in rampart config

AXIS2_EXTERN axutil_array_list_t* rampart_config_get_saml_tokens | ( | rampart_config_t * | rampart_config,
|  | const axutil_env_t * | env |
| ) |  |  |

Gets stored SAML token

Parameters:

  | rampart_config | rampart configuration structure
  | evn | pointer to environment struct,Must not be NULL. returns SAML token stored in rampart config

AXIS2_EXTERN int rampart_config_get_ttl | ( | rampart_config_t * | rampart_config,
|  | const axutil_env_t * | env |
| ) |  |  |

Gets stored time to live

Parameters:

  | rampart_config | rampart configuration structure
  | evn | pointer to environment struct,Must not be NULL. returns time to live parameter stored in rampart config

AXIS2_EXTERN axis2_char_t* rampart_config_get_username | ( | rampart_config_t * | rampart_config,
|  | const axutil_env_t * | env |
| ) |  |  |

Gets stored username

Parameters:

  | rampart_config | rampart configuration structure
  | evn | pointer to environment struct,Must not be NULL. returns username stored in rampart config

AXIS2_EXTERN axis2_status_t rampart_config_set_issued_token_aquire_function | ( | rampart_config_t * | rampart_config,
|  | const axutil_env_t * | env,
|  | issued_token_callback_func | issued_token_aquire |
| ) |  |  |

sets function pointer used to aquire issued token

Parameters:

  | rampart_config | rampart configuration structure
  | evn | pointer to environment struct,Must not be NULL.
  | issued_token_aquire | function pointer from which issued token will be obtained

Returns:
  status of the op.

AXIS2_EXTERN axis2_status_t rampart_config_set_password | ( | rampart_config_t * | rampart_config,
|  | const axutil_env_t * | env,
|  | axis2_char_t * | password |
| ) |  |  |

set password of the user. Will be used to build UsernameToken

Parameters:

  | rampart_config | rampart configuration structure
  | evn | pointer to environment struct,Must not be NULL.
  | password | password of the user

Returns:
  status of the op.

AXIS2_EXTERN axis2_status_t rampart_config_set_password_type | ( | rampart_config_t * | rampart_config,
|  | const axutil_env_t * | env,
|  | axis2_char_t * | password_type |
| ) |  |  |

set password type needed. Will be used to build UsernameToken

Parameters:

  | rampart_config | rampart configuration structure
  | evn | pointer to environment struct,Must not be NULL.
  | password_type | type of the password. (hash/plain)

Returns:
  status of the op.

AXIS2_EXTERN axis2_status_t rampart_config_set_ttl | ( | rampart_config_t * | rampart_config,
|  | const axutil_env_t * | env,
|  | int | ttl |
| ) |  |  |

sets time to live parameter needed by Timestamp element

Parameters:

  | rampart_config | rampart configuration structure
  | evn | pointer to environment struct,Must not be NULL.
  | ttl | time to live value in seconds

Returns:
  status of the op.

AXIS2_EXTERN axis2_status_t rampart_config_set_username | ( | rampart_config_t * | rampart_config,
|  | const axutil_env_t * | env,
|  | axis2_char_t * | user |
| ) |  |  |

set username needed to build username token

Parameters:

  | rampart_config | rampart configuration structure
  | evn | pointer to environment struct,Must not be NULL.
  | user | name of the user

Returns:
  status of the op. AXIS2_SUCCESS on success and AXIS2_FAILURE on error